#include "stdafx.h"
#include "pole.h"


Pole::Pole(unsigned int inicialniVelikost)
{
	// alokujeme nove pole objektu dane velikosti
	this->pole = new Object[inicialniVelikost];
	// a zapamatujeme si jeho velikost
	this->velikost = inicialniVelikost;
}

Pole::~Pole()
{
	delete[] pole;
}

void Pole::Vloz(Object & o, unsigned int index)
{
	// pokud chce nekdo vlozit az za pole, kde uz nemame alokovano,
	// musime ho prodlouzit
	if (index >= velikost)
	{
		// prodlouzime o mocniny dvojky, aby se zabranilo moc castemu
		// prodluzovani

		// starou velikost pole musime zachovat, abychom vedeli kolik kopirovat,
		// udelame si novou promennou
		unsigned int nova_velikost;
		nova_velikost = velikost;
		do
		{ // zvetsujeme na dvojnasobek, dokud nam to nestaci
			nova_velikost *= 2;
		}
		while (index >= nova_velikost);

		// alokujeme nove pole
		Object * nove_pole = new Object[nova_velikost];
		// zkopirujeme do nej to co mame ve stavajicim
		for(unsigned int i = 0; i < velikost; i++)
		{
			nove_pole[i] = pole[i];
		}
		// stavajici odalokujeme
		delete[] pole;
		// a zapamtujeme si v objektu ukazatel na nove a novou velikost
		pole = nove_pole;
		velikost = nova_velikost;
	}

	// a vkladame, at uz jsme prodluzovali nebo ne
	pole[index] = o;
}

Object & Pole::Get(unsigned int index)
{
	// jeste by melo byt ohlidani indexu, jestli je < velikost

	// pouze vracime prvek na dane pozici
	return pole[index];
}
